# RegionTrees.jl: Quadtrees, Octrees, and their N-Dimensional Cousins

[![Build Status](https://github.com/JuliaGeometry/RegionTrees.jl/workflows/CI/badge.svg)](https://github.com/JuliaGeometry/RegionTrees.jl/actions?query=workflow%3ACI)
[![codecov](https://codecov.io/gh/JuliaGeometry/RegionTrees.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/JuliaGeometry/RegionTrees.jl)

This Julia package is a lightweight framework for defining N-Dimensional region trees. In 2D, these are called *region quadtrees*, and in 3D they are typically referred to as *octrees*. A region tree is a simple data structure used to describe some kind of spatial data with varying resolution. Each element in the tree can be a leaf, representing an N-dimensional rectangle of space, or a node which is divided exactly in half along each axis into 2^N children. In addition, each element in a `RegionTrees.jl` tree can carry an arbitrary data payload. This makes it easy to use `RegionTrees` to approximate functions or describe other interesting spatial data.

## Features

* Lightweight code with few dependencies (only `StaticArrays.jl` and `Iterators.jl` are required)
* Optimized for speed and for few memory allocations
    * Liberal use of `@generated` functions lets us unroll most loops and prevent allocating temporary arrays
* Built-in support for general adaptive sampling techniques

## Usage

See [examples/demo/demo.ipynb](examples/demo/demo.ipynb) for a tour through the API. You can also check out:

* [examples/adaptive_distance_fields/adaptive_distances.ipynb](examples/adaptive_distance_fields/adaptive_distances.ipynb) for an adaptively-sampled distance field, or [AdaptiveDistanceFields.jl](https://github.com/rdeits/AdaptiveDistanceFields.jl) for a more complete example [1]
* [examples/adaptive_mpc/adaptive_mpc.ipynb](examples/adaptive_mpc/adaptive_mpc.ipynb) for an adaptive approximation of a model-predictive controller

[1] Frisken et al. "Adaptively Sampled Distance Fields: A General Representation of Shape for Computer Graphics". SIGGRAPH 2000.

## Gallery

An adaptively sampled distance field, from `examples/adaptive_distances.ipynb`:

![](http://rdeits.github.io/RegionTrees.jl/img/distance.svg)

An adaptively sampled model-predictive control problem, from `examples/adaptive_mpc.ipynb`:

![](http://rdeits.github.io/RegionTrees.jl/img/mpc.svg)

An adaptive distance field in 3D, from [AdaptiveDistanceFields.jl](https://github.com/rdeits/AdaptiveDistanceFields.jl):

![](http://rdeits.github.io/RegionTrees.jl/img/distance_3d.png)

## Related Packages

* [Morton.jl](https://github.com/JaneliaSciComp/Morton.jl)
* [Interpolations.jl](https://github.com/JuliaMath/Interpolations.jl)

module RegionTrees

using StaticArrays
import StaticArrays: similar_type, Size
import Base: show, size, getindex, convert, parent, @pure
export Cell,
       split!,
       isleaf,
       findleaf,
       children,
       parent,
       child_boundary,
       HyperRectangle,
       center,
       vertices,
       faces,
       body_and_face_centers,
       AbstractRefinery,
       needs_refinement,
       refine_data,
       initial_data,
       allcells,
       allleaves,
       allparents,
       adaptivesampling!

include("twosarray.jl")
include("hyperrectangle.jl")
include("cell.jl")
include("adaptivesampling.jl")

end

abstract type AbstractRefinery end

needs_refinement(refinery::AbstractRefinery, cell) = error("Your refinery should implement this function")
refine_data(refinery::AbstractRefinery, cell, indices) = error("Your refinery should implement this function")

function adaptivesampling!(root::Cell, refinery::AbstractRefinery)
    refinement_queue = [root]
    refine_function =
        (cell, indices) -> refine_data(refinery, cell, indices)
    while !isempty(refinement_queue)
        cell = pop!(refinement_queue)
        if isleaf(cell)
            if needs_refinement(refinery, cell)
                split!(cell, refine_function)
                append!(refinement_queue, children(cell))
            end
        else
            append!(refinement_queue, children(cell))
        end
    end
    root
end

@testset "parents and children" begin
    cell = Cell(SVector(-1., -2, -3), SVector(2., 4, 6), 0)
    @test cell.boundary.origin == SVector(-1., -2, -3)
    @test cell.boundary.widths == SVector(2., 4, 6)
    @test cell.children === nothing
    @test isleaf(cell)

    split!(cell, [i for i in 1:8])
    @test !isleaf(cell)
    @test cell[1,1,1].boundary.origin == cell.boundary.origin
    @test cell[2,2,2].boundary.origin + cell[2,2,2].boundary.widths == cell.boundary.origin + cell.boundary.widths
    @test cell[1,1,1].data == 1
    @test cell[2,1,1].data == 2
    for child in children(cell)
        @test parent(child) === cell
    end
end

@testset "type promotions" begin
    c1 = RegionTrees.Cell(SVector(0.0, 0.0), SVector(1.0, 1.0))
    @test typeof(c1.boundary.origin) == SVector{2, Float64}
    c2 = RegionTrees.Cell(SVector(0, 0), SVector(1, 1))
    @test typeof(c2.boundary.origin) == SVector{2, Float64}

    @inferred RegionTrees.Cell(SVector(0, 0), SVector(1, 1))
    @inferred RegionTrees.Cell(SVector(0.0, 0.0), SVector(1.0, 1.0))
end

@testset "find leaf" begin
    cell = Cell(SVector(-1., -2, -3), SVector(2., 4, 6), 0)
    @test findleaf(cell, SVector(-0.01, -0.01, -0.01)) === cell

    split!(cell, [0 for i in 1:8])
    @test findleaf(cell, SVector(-0.01, -0.01, -0.01)) === cell[1,1,1]
    @test findleaf(cell, SVector(0.01, -0.01, -0.01)) === cell[2,1,1]
end

@testset "find parents" begin
	cell2D = Cell(SVector(0., 0), SVector(1., 1))
	split!(cell2D)
	split!(cell2D[1,1])
	parents2D = [p for p in allparents(cell2D[1,1][1,2])]

	@test parents2D[1] === cell2D[1,1]
	@test parents2D[2] === cell2D

	cell3D = Cell(SVector(-1., -2, -3), SVector(2., 4, 6), 0)
	split!(cell3D)
	split!(cell3D[2,2,2])
	parents3D = [p for p in allparents(cell3D[2,2,2][1,1,1])]

	@test parents3D[1] === cell3D[2,2,2]
	@test parents3D[2] === cell3D

	noparents = [p for p in allparents(cell2D)]
	@test length(noparents) == 0
end

@testset "non-float64 types" begin
    # https://github.com/rdeits/RegionTrees.jl/pull/22
    root = Cell(SVector(0f0, 0f0, 0f0), SVector(1f0, 1f0, 1f0))
    split!(root)
    @test length(root.children) == 8
    @test center(root) == SVector(0.5f0, 0.5f0, 0.5f0)
    @test typeof(center(root)) == SVector{3, Float32}
end

@testset "allcells, alleaves, allparents functions" begin
    r = MyRefinery(0.5)
    root = Cell(SVector(0., 0), SVector(1., 1), "root")
    adaptivesampling!(root, r)

    ac = allcells(root)
    @test typeof(ac) == Channel{Cell{String, 2, Float64, 4}}
    acv = collect(ac)
    @test typeof(acv) == Vector{Cell{String, 2, Float64, 4}}
    @test size(acv, 1) == 5

    al = allleaves(root)
    @test typeof(al) == Channel{Cell{String, 2, Float64, 4}}
    alv = collect(al)
    @test typeof(alv) == Vector{Cell{String, 2, Float64, 4}}
    @test size(alv, 1) == 4

    leaf = alv[1]
    ap = allparents(leaf)
    @test typeof(ap) == Channel{Cell{String, 2, Float64, 4}}
    apv = collect(ap)
    @test typeof(apv) == Vector{Cell{String, 2, Float64, 4}}
    @test size(apv, 1) == 1
end

using Test
using RegionTrees
using StaticArrays
using LinearAlgebra

struct MyRefinery <: AbstractRefinery
    tolerance::Float64
end

function RegionTrees.needs_refinement(r::MyRefinery, cell)
    maximum(cell.boundary.widths) > r.tolerance
end

function RegionTrees.refine_data(r::MyRefinery, cell::Cell, indices)
    boundary = child_boundary(cell, indices)
    "child with widths: $(boundary.widths)"
end

include("hyperrectangle.jl")
include("cell.jl")
include("twosarray.jl")
include("adaptivesampling.jl")
include("asdfs.jl")

"""
Represents a static array with N dimensions whose size is
exactly 2 along each dimension. This makes templating on
the number of dimensions easier than with a regular
SArray.
"""
struct TwosArray{N, T, L} <: StaticArray{NTuple{N, 2}, T, N}
    data::NTuple{L, T}
end

@generated function TwosArray(x::NTuple{L, T}) where {L, T}
    @assert log2(L) == round(log2(L)) "L must equal 2^N for integer N"
    N = Int(log2(L))
    :(TwosArray{$N, T, L}(x))
end

getindex(b::TwosArray, i::Int) = b.data[i]

"""
Highly specialized selectdim implementation for TwosArray (an array of size
2 along every dimension). Returns a TwosArray with N-1 dimensions. See
`test/twosarray.jl` for exhaustive testing of this function. This is about
100 times faster than Julia's base selectdim().
"""
@generated function Base.selectdim(A::TwosArray{N, T}, d::Integer, i::Integer) where {N, T}
    quote
        x = 2^(d - 1)
        j = 1
        k = 1
        TwosArray($(Expr(:tuple, [quote
            z = j
            j += 1
            if k < x
                k += 1
            else
                j += x
                k = 1
            end
            A[z + (i - 1) * x]
        end for n in 1:(2^(N - 1))]...)))
    end
end

similar_type(::Type{TwosArray{N, T, L}}, ::Type{T2}) where {N, T, L, T2} = TwosArray{N, T2, L}

module AdaptivelySampledDistanceFields

using StaticArrays
using RegionTrees
import RegionTrees: needs_refinement, refine_data
using Interpolations

@generated function evaluate(itp::AbstractInterpolation, point::SVector{N}) where N
    Expr(:call, :itp, [:(point[$i]) for i in 1:N]...)
end

function evaluate(itp::AbstractInterpolation, point::AbstractArray)
    itp(point...)
end

function evaluate(cell::Cell{D}, point::AbstractArray) where D <: AbstractInterpolation
    leaf = findleaf(cell, point)
    evaluate(leaf.data, leaf.boundary, point)
end

function evaluate(interp::AbstractInterpolation, boundary::HyperRectangle, point::AbstractArray)
    coords = (point .- boundary.origin) ./ boundary.widths .+ 1
    evaluate(interp, coords)
end

mutable struct SignedDistanceRefinery{F <: Function} <: AbstractRefinery
    signed_distance_func::F
    atol::Float64
    rtol::Float64
end

function needs_refinement(refinery::SignedDistanceRefinery, cell::Cell)
    minimum(cell.boundary.widths) > refinery.atol && needs_refinement(cell, refinery.signed_distance_func, refinery.atol, refinery.rtol)
end

function needs_refinement(cell::Cell, signed_distance_func, atol, rtol)
    for c in body_and_face_centers(cell.boundary)
        value_interp = evaluate(cell, c)
        value_true = signed_distance_func(c)
        if !isapprox(value_interp, value_true, rtol=rtol, atol=atol)
            return true
        end
    end
    false
end

function refine_data(refinery::SignedDistanceRefinery, cell::Cell, indices)
    refine_data(refinery, child_boundary(cell, indices))
end

function refine_data(refinery::SignedDistanceRefinery, boundary::HyperRectangle)
    interpolate!(refinery.signed_distance_func.(vertices(boundary)),
                 BSpline(Linear()))
end

function ASDF(signed_distance::Function, origin::AbstractArray,
              widths::AbstractArray,
              rtol=1e-2,
              atol=1e-2)
    refinery = SignedDistanceRefinery(signed_distance, atol, rtol)
    boundary = HyperRectangle(origin, widths)
    root = Cell(boundary, refine_data(refinery, boundary))
    adaptivesampling!(root, refinery)
end


end

struct HyperRectangle{N, T}
    origin::SVector{N, T}
    widths::SVector{N, T}
end

@generated function vertices(rect::HyperRectangle{N}) where N
    verts = Expr[]
    for I in CartesianIndices(tuple([2 for i in 1:N]...))
        push!(verts,
        Expr(:call,
        :SVector,
        [I[i] == 1 ? :(rect.origin[$i]) : :(rect.origin[$i] + rect.widths[$i]) for i in 1:N]...))
    end
    Expr(:call, :TwosArray, verts...)
end

center(rect::HyperRectangle) = rect.origin + rect.widths / 2

convert(::Type{HyperRectangle{N, T2}}, r::HyperRectangle{N, T1}) where {N, T1, T2} =
    HyperRectangle{N, T2}(convert(SVector{N, T2}, r.origin),
                          convert(SVector{N, T2}, r.widths))

@generated function faces(rect::HyperRectangle{N}) where N
    quote
        verts = vertices(rect)
        SVector($(Expr(:tuple, [:(selectdim(verts, $d, $i)) for i in 1:2 for d in 1:N]...)))
    end
end


struct BodyAndFaceCenters{N, T}
    rect::HyperRectangle{N, T}
end

function Base.iterate(b::BodyAndFaceCenters{N, T}, i=0) where {N, T}
    if i > 2 * N
        return nothing
    elseif i == 0
        return center(b.rect), i + 1
    else
        @inbounds f = faces(b.rect)[i]
        return sum(f) ./ length(f), i + 1
    end
end

Base.length(iter::BodyAndFaceCenters{N}) where {N} = 2 * N + 1
Base.eltype(iter::BodyAndFaceCenters{N, T}) where {N, T} = SVector{N, T}

body_and_face_centers(rect::HyperRectangle) = BodyAndFaceCenters(rect)

@testset "adaptive sampling" begin
    r = MyRefinery(0.5)
    root = Cell(SVector(0.0, 0), SVector(1.0, 1), "root")

    adaptivesampling!(root, r)
    @test length(collect(allleaves(root))) == 4
    adaptivesampling!(root, r)
    @test length(collect(allleaves(root))) == 4
end

@testset "adaptively sampled distance fields" begin
    include("../examples/adaptive_distance_fields/adaptive_distance_fields.jl")
    import .AdaptivelySampledDistanceFields: ASDF, evaluate
    import StaticArrays: SVector

    signed_distance = x -> norm(x - SVector(0, 0))
    origin = SVector(-1, -1)
    widths = SVector(2, 2)
    root = ASDF(signed_distance, origin, widths, 1e-2, 1e-2)
    @test evaluate(root, [0, 0]) == 0
    @test evaluate(root, SVector(0, 0)) == 0
    @test findleaf(root, [0.01, -0.01]).boundary.origin == [0.0, -0.0625]
    @test findleaf(root, [0.01, -0.01]).boundary.widths == [0.0625, 0.0625]

    for leaf in allleaves(root)
        @test isleaf(leaf)
    end
    @test_broken length(collect(allleaves(root))) == 112
    @test_broken length(collect(allcells(root))) == 149
end

mutable struct Cell{Data, N, T, L}
    boundary::HyperRectangle{N, T}
    data::Data
    divisions::SVector{N, T}
    children::Union{TwosArray{N, Cell{Data, N, T, L}, L}, Nothing}
    parent::Union{Cell{Data, N, T, L}, Nothing}
end

function Cell(origin::SVector{N, T}, widths::SVector{N, T}, data::Data=nothing) where {Data, N, T}
    Cell(HyperRectangle(origin, widths), data)
end

@generated function Cell(boundary::HyperRectangle{N, T}, data::Data=nothing) where {Data, N, T}
    L = 2^N
    return quote
        T2 = Base.promote_op(/, T, Int)
        Cell{Data, N, T2, $L}(boundary,
             data,
             boundary.origin + boundary.widths / 2,
             nothing,
             nothing)
    end
end

@inline isleaf(cell::Cell) = cell.children === nothing
@inline children(cell::Cell) = cell.children
@inline parent(cell::Cell) = cell.parent
@inline center(cell::Cell) = center(cell.boundary)
@inline vertices(cell::Cell) = vertices(cell.boundary)

@inline size(::Type{C}) where {C <: Cell} = ()
@inline size(cell::Cell) = size(typeof(cell))

show(io::IO, cell::Cell) = print(io, "Cell: $(cell.boundary)")

@inline getindex(cell::Cell) = cell
@inline getindex(cell::Cell, ::CartesianIndex{0}) = cell
@inline getindex(cell::Cell, I) = getindex(cell.children, I)
@inline getindex(cell::Cell, I...) = getindex(cell.children, I...)

function child_boundary(cell::Cell, indices)
    half_widths = cell.boundary.widths ./ 2
    HyperRectangle(
        cell.boundary.origin .+ (SVector(indices) .- 1) .* half_widths,
        half_widths)
end

@generated function map_children(f::Function, cell::Cell{Data, N, T, L}) where {Data, N, T, L}
    Expr(:call, :TwosArray, Expr(:tuple,
        [:(f(cell, $(I.I))) for I in CartesianIndices(ntuple(_ -> 2, Val(N)))]...))
end


child_indices(cell::Cell{Data, N, T, L}) where {Data, N, T, L} = child_indices(Val(N))

@generated function child_indices(::Val{N}) where N
    Expr(:call, :TwosArray, Expr(:tuple,
        [I.I for I in CartesianIndices(ntuple(_ -> 2, Val(N)))]...))
end

function split!(cell::Cell{Data, N}) where {Data, N}
    split!(cell, (c, I) -> cell.data)
end

@generated function split!(cell::Cell{Data, N}, child_data::AbstractArray) where {Data, N}
    split!_impl(cell, child_data, Val(N))
end

split!(cell::Cell, child_data_function::Function) =
    split!(cell, map_children(child_data_function, cell))

function split!_impl(::Type{C}, child_data, ::Val{N}) where {C <: Cell, N}
    child_exprs = [:(Cell(child_boundary(cell, $(I.I)),
                          child_data[$i])) for (i, I) in enumerate(CartesianIndices(ntuple(_ -> 2, Val(N))))]
    quote
        @assert isleaf(cell)
        cell.children = $(Expr(:call, :TwosArray, Expr(:tuple, child_exprs...)))
        for child in cell.children
            child.parent = cell
        end
        cell
    end
end

@generated function findleaf(cell::Cell{Data, N}, point::AbstractVector) where {Data, N}
    quote
        while true
            if isleaf(cell)
                return cell
            end
            length(point) == $N || throw(DimensionMismatch("expected a point of length $N"))
            @inbounds cell = $(Expr(:ref, :cell, [:(ifelse(point[$i] >= cell.divisions[$i], 2, 1)) for i in 1:N]...))
        end
    end
end

function allcells(cell::Cell{Data, N, T, L}) where {Data, N, T, L}
    Channel{Cell{Data, N, T, L}}() do c
        queue = [cell]
        while !isempty(queue)
            current = pop!(queue)
            put!(c, current)
            if !isleaf(current)
                append!(queue, children(current))
            end
        end
    end
end

function allleaves(cell::Cell{Data, N, T, L}) where {Data, N, T, L}
    Channel{Cell{Data, N, T, L}}() do c
        for child in allcells(cell)
            if isleaf(child)
                put!(c, child)
            end
        end
    end
end

function allparents(cell::Cell{Data, N, T, L}) where {Data, N, T, L}
    Channel{Cell{Data, N, T, L}}() do c
        queue = [cell]
        while !isempty(queue)
            current = pop!(queue)
            p = parent(current)
            if ! (p === nothing)
                put!(c, p)
                push!(queue, p)
            end
        end
    end
end
